任务描述123
本关任务：实现学生成绩管理系统。
相关知识
为了完成本关任务，你需要掌握：C 语言基础和数据结构相关知识。
系统介绍
本学生成绩管理系统是为教师提供管理班级成绩的工具，该系统可以实现的对学生的成绩进行增、删、改、查、信息保存和信息导入等基本功能，以及对学生成绩排序和分段的扩展功能，有利于对学生成绩管理。
设计思想
利用结构体——定义STU结构体存储学生学号、姓名、各科成绩，总成绩和平均成绩，利用文件来存储，读取数据。
功能描述
(1) 创建学生基本信息，便于之后查询和浏览；
(2) 录入各科学习成绩；
(3) 计算每个学生各门课程的总分和平均分；
(4)计算每门课程的总分和平均分;
(5) 按每个学生的总分由高到低排出名次表；
(6) 按每个学生的总分由低到高排出名次表；
(7) 按学号由小到大排出成绩表；
(8) 按姓名的字母顺序排出成绩表；
(9) 按学号查询学生排名及其考试成绩；
(10) 按姓名查询学生排名及其考试成绩；
(11) 按优秀（90~100）、良好（80~89）、中等（70~79）、及格（60~69）、不及格（0~59）5个类别，对每门课程分别统计每个类别的人数以及所占的百分比；
(12) 输出每个学生的学号、姓名、各科考试成绩，以及每门课程的总分和平均分；
(13) 将每个学生的记录信息写入文件；
(14) 从文件中读出每个学生的记录信息并显示。
功能设计
成绩录入
设计思想： 成绩录入是对结构体中班级、姓名、学号和五门成绩的录入，同时加上对五门成绩平均成绩的计算。按照基本的录入，只需用 scanf 函数对数据输入，用 printf 函数进行汉字的打印即可。然后进行文件保存该组数据，最后判断是否继续录入。
计算分数
设计思想：通过学号查找到该学生的结构体，通过结构体找到各科的成绩，然后进行求和和平均。
计算每门课程的总分和平均分
1.// 函数功能：计算每门课程的总分和平均分 
2.void  AverSumofEveryCourse(STU stu[], int n, int m)  // stu[i].sum=
3.{
4.    int i, j;
5.     float sum[COURSE_NUM], aver[COURSE_NUM];
6.    for (j=0; j<m; j++)
7.    {
8.        sum[j] = 0;
9.        for (i=0; i<n; i++)
10.        {
11.            sum[j] = sum[j] + stu[i].score[j];
12.        }
13.        aver[j] = n>0 ? sum[j] / n : -1;
14.printf("course %d:sum=%.0f, aver=%.0f\n",j+1,sum[j],aver[j]);
15.    }
16.}
成绩排序
设计思想： 成绩排序是将结构体中的数据按平均成绩进行排序，在本系统中，我将成绩排序非为按五门成绩排序和平均成绩排序，排序的思想是运用选择排序。选择不同的函数功能进行排序。在此功能中需注意的是排序时要将整组数据随着平均成绩一起改变，最后不能出现平均成绩与信息对应不上。其次在进行字符串互换的时候不能直接赋值号进行互换，要用 strcpy 函数进行复制。
选择函数功能排出名次表
1.// 使数据按升序排序 
2.int Ascending(float a, float b)
3.{
4.    return a < b;     // 这样比较决定了按升序排序，如果a<b，则交换 
5.}
6.// 使数据按降序排序 
7.int Descending(float a, float b)
8.{
9.    return a > b;    // 这样比较决定了按降序排序，如果a>b，则交换 
10.}
11.// 交换两个单精度浮点型数据 
12.void  SwapFloat(float *x, float *y)
13.{
14.float  temp;
15.temp = *x; 
16.*x = *y;  
17.*y = temp;
18.}
19.// 交换两个长整型数据 
20.void  SwapLong(long *x, long *y)
21.{
22.    long   temp;
23.temp = *x; 
24.*x = *y;  
25.*y = temp;
26.}
27.// 交换两个字符串 
28.void  SwapChar(char x[], char y[])
29.{
30.    char temp[MAX_LEN];
31.strcpy(temp, x);
32.strcpy(x, y);
33.strcpy(y, temp);
34.}
35.// 函数功能：按选择法将数组num的元素值按从低到高排序 
36.void AsSortbyNum(STU stu[], int n, int m)
37.{
38.    int  i, j, k, t;
39.    for (i=0; i<n-1; i++)
40.    {
41.        k = i;
42.        for (j=i+1; j<n; j++)
43.        {
44.            if (stu[j].num < stu[k].num)    k = j;
45.        }
46.        if (k != i)
47.        {
48.            for (t=0; t<m; t++)            // 交换m门课程的成绩 
49.              {
50.                   SwapFloat(&stu[k].score[t], &stu[i].score[t]);
51.            }
52.SwapFloat(&stu[k].sum, &stu[i].sum);    // 交换总分 
53.SwapFloat(&stu[k].aver, &stu[i].aver); // 交换平均分   
54.SwapLong(&stu[k].num, &stu[i].num);     // 交换学号 
55.SwapChar(stu[k].name, stu[i].name);     // 交换姓名 
56.        }
57.    }
58.}
成绩查找
设计思想： 成绩查找需要实现的是按学号和姓名查找到学生的所有信息，然后打印出来。该功能的思想是输入学号或姓名，然后在循环体中对结构体进行遍历，找到所查到的结构体的下标值，然后将该下标值对应学生的信息打印出来。按照姓名查询时，判断字符串是否相等需要用 strcmp 函数。在循环体中对结构体进行遍历的时候，找到的时候，可以用 break 跳出循环，提高效率。

学生成绩管理系统代码


#include <stdio.h>
#include  <string.h>
#define   MAX_LEN  10                    	// 字符串最大长度 
#define   STU_NUM 30                       // 最多的学生人数 
#define   COURSE_NUM 6                     // 最多的考试科目数 
typedef struct student
{
		long num;						// 每个学生的学号 
		char name[MAX_LEN];            	// 每个学生的姓名 
		float score[COURSE_NUM];		// 每个学生COURSE_NUM门功课的成绩 
		float sum;                   	     // 每个学生的总成绩 
		float aver;               	     // 每个学生的平均成绩 
}STU;
int   Menu(void);
void  ReadScore(STU stu[], int n, int m);
void  AverSumofEveryStudent(STU stu[], int n, int m);
void  AverSumofEveryCourse(STU stu[], int n, int m);
void  SortbyScore(STU stu[],int n,int m,int (*compare)(float a,float b));
int   Ascending(float a, float b);
int   Descending(float a, float b);
void  SwapFloat(float *x, float *y);
void  SwapLong(long *x, long *y);
void  SwapChar(char x[], char y[]);
void  AsSortbyNum(STU stu[], int n, int m);
void  SortbyName(STU stu[], int n, int m);
void  SearchbyNum(STU stu[], int n, int m);
void  SearchbyName(STU stu[], int n, int m);
void  StatisticAnalysis(STU stu[], int n, int m);
void  PrintScore(STU stu[], int n, int m);
void  WritetoFile(STU record[], int n, int m);
void  ReadfromFile(STU record[], int *n, int *m);
int main(void)
{
	char  ch;
	int   n = 0, m = 0;
	STU   stu[STU_NUM];	
printf("Input student number(n<%d):", STU_NUM);
	scanf("%d", &n);
printf("Input course number(m<=%d):",COURSE_NUM);
	scanf("%d", &m);
	while (1)
	{
		ch = Menu();					    // 显示菜单，并读取用户输入 		
		switch (ch)
		{
			case 1:ReadScore(stu, n, m);
					break;
			case 2: AverSumofEveryCourse(stu, n, m);                        
					break;
            case 3: AverSumofEveryStudent(stu, n, m);                    
					break;
			case 4: SortbyScore(stu, n, m, Descending);
					printf("\nSort in descending order by score:\n");
					PrintScore(stu, n, m);
					break;
			case 5: SortbyScore(stu, n, m, Ascending);
					printf("\nSort in ascending order by score:\n");
					PrintScore(stu, n, m);
					break;
			case 6: AsSortbyNum(stu, n, m);
					printf("\nSort in ascending order by number:\n");
					PrintScore(stu, n, m);
					break;
			case 7: SortbyName(stu, n, m);
					printf("\nSort in dictionary order by name:\n");
					PrintScore(stu, n, m);
					break;
			case 8: SearchbyNum(stu, n, m);
					break;
			case 9: SearchbyName(stu, n, m);
					break;
			case 10: StatisticAnalysis(stu, n, m);
					break;
			case 11:PrintScore(stu, n, m);
					break;
case 12:WritetoFile(stu, n, m);
				     break;
			case 13:ReadfromFile(stu, &n, &m);
				     break;
			case 0: printf("End of program!");
			       	exit(0);
			default:printf("Input error!");
		}
	}
	return 0;}
//  函数功能：显示菜单并获得用户键盘输入的选项 
int Menu(void)
{
		int itemSelected;
		printf("Management for Students' scores\n");
		printf("1.Input record\n");
		printf("2.Calculate total and average score of every course\n");
		printf("3.Calculate total and average score of every student\n");
		printf("4.Sort in descending order by score\n");
		printf("5.Sort in ascending order by score\n");
		printf("6.Sort in ascending order by number\n");
		printf("7.Sort in dictionary order by name\n");
		printf("8.Search by number\n");
		printf("9.Search by name\n");
		printf("10.Statistic analysis\n");
		printf("11.List record\n");
		printf("12.Write to a file\n");
		printf("13.Read from a file\n");
		printf("0.Exit\n");
		printf("Please Input your choice:");
		scanf("%d", &itemSelected); 	// 读入用户输入 
		return itemSelected;
}
// 函数功能：输入n个学生的m门课成绩 
void ReadScore(STU stu[], int n, int m)
{
	int i, j;
	printf("Input student's ID, name and score:\n");
    /* ---------- begain ---------- */
    for(i=0;i<n;i++)
    {scanf("%ld%s",&stu[i].num,stu[i].name);
     for (j=0; j<m; j++)
     scanf("%f",&stu[i].score[j]);
    }

    /* ----------- end ----------- */
}
// 函数功能：计算每个学生各门课程的总分和平均分 
void AverSumofEveryStudent(STU stu[], int n, int m)
{
	int i, j;
	for (i=0; i<n; i++)
	{
	    stu[i].sum = 0;
	    for (j=0; j<m; j++)
	    {
            stu[i].sum = stu[i].sum + stu[i].score[j];
	    }
	    stu[i].aver = m>0 ? stu[i].sum / m : -1;
	    printf("student %d: sum = %.0f, aver = %.0f\n", 
i+1, stu[i].sum, stu[i].aver);
	}	
}
// 函数功能：计算每门课程的总分和平均分 
void  AverSumofEveryCourse(STU stu[], int n, int m)
{
	int i, j;
    float sum[COURSE_NUM], aver[COURSE_NUM];
    /* ---------- begain ---------- */
	for (j=0; j<m; j++)
	{
	    sum[j] = 0;
	    for (i=0; i<n; i++)
	    {
            sum[j] +=  stu[i].score[j];
	    }
        aver[j]=sum[j]/i;
        printf("student %d: sum = %.0f, aver = %.0f\n", 
j+1, sum[j], aver[j]); 
    }
    /* ----------- end ----------- */
}
// 函数功能：按选择法将数组sum的元素值排序 
void SortbyScore(STU stu[],int n,int m,int (*compare)(float a,float b))
{
	int  i, j, k, t;
	for (i=0; i<n-1; i++)
	{
		k = i;
		for (j=i+1; j<n; j++)
		{
			if ((*compare)(stu[j].sum, stu[k].sum)) k = j;
		}
		if (k != i)
		{		   
		   for (t=0; t<m; t++)             // 交换m门课程的成绩 
            {
                SwapFloat(&stu[k].score[t], &stu[i].score[t]);
            }
SwapFloat(&stu[k].sum, &stu[i].sum);    // 交换总分 
SwapFloat(&stu[k].aver, &stu[i].aver); // 交换平均分   
SwapLong(&stu[k].num, &stu[i].num);     // 交换学号 
SwapChar(stu[k].name, stu[i].name);     // 交换姓名 
		}
	}
}
// 使数据按升序排序 
int Ascending(float a, float b)
{
	return a < b;     // 这样比较决定了按升序排序，如果a<b，则交换 
}
// 使数据按降序排序 
int Descending(float a, float b)
{
	return a > b;    // 这样比较决定了按降序排序，如果a>b，则交换 
}
// 交换两个单精度浮点型数据 
void  SwapFloat(float *x, float *y)
{
float  temp;
temp = *x; 
*x = *y;  
*y = temp;
}
// 交换两个长整型数据 
void  SwapLong(long *x, long *y)
{
long   temp;
temp = *x; 
*x = *y;  
*y = temp;
}
// 交换两个字符串 
void  SwapChar(char x[], char y[])
{
char temp[MAX_LEN];
strcpy(temp, x);
strcpy(x, y);
strcpy(y, temp);
}
// 函数功能：按选择法将数组num的元素值按从低到高排序 
void AsSortbyNum(STU stu[], int n, int m)
{
	int  i, j, k, t;
	for (i=0; i<n-1; i++)
	{
        /* ---------- begain ---------- */
		
        /* ----------- end ----------- */
	}
}
// 函数功能：交换法实现字符串按字典顺序排序 
void SortbyName(STU stu[], int n, int m)
{
	int  i, j, t;
	for (i=0; i<n-1; i++)
	{
		  for (j = i+1; j<n; j++)
		  {
			  if (strcmp(stu[j].name, stu[i].name) < 0)
			  {				  
				  for (t=0; t<m; t++)// 交换m门课程的成绩 
                     {
				      SwapFloat(&stu[i].score[t], &stu[j].score[t]);
			       } 
SwapFloat(&stu[i].sum, &stu[j].sum);    // 交换总分 
SwapFloat(&stu[i].aver, &stu[j].aver); // 交换平均分   
SwapLong(&stu[i].num, &stu[j].num);     // 交换学号 
SwapChar(stu[i].name, stu[j].name);     // 交换姓名 
			  }
		  }
	 }
}
// 函数功能：按学号查找学生成绩并显示查找结果 
void SearchbyNum(STU stu[], int n, int m)
{
	long  number;
	int   i, j;
	printf("Input the number you want to search:");
	scanf("%ld", &number);
    
    /* ---------- begain ---------- */
	
    /* ----------- end ----------- */
	
	printf("\nNot found!\n");
}
// 函数功能：按姓名的字典顺序排出成绩表 
void SearchbyName(STU stu[], int n, int m)
{
	char x[MAX_LEN];
	int  i, j;
	printf("Input the name you want to search:");
	scanf("%s", x);
	for (i=0; i<n; i++)
	{
		if (strcmp(stu[i].name, x) == 0)
		{
			printf("%ld\t%s\t", stu[i].num, stu[i].name);
			for (j=0; j<m; j++)
			{
				printf("%.0f\t", stu[i].score[j]);
			}
			printf("%.0f\t%.0f\n", stu[i].sum, stu[i].aver);
			return;
		}
	}
	printf("\nNot found!\n");
}
// 函数功能：统计各分数段的学生人数及所占的百分比 
void StatisticAnalysis(STU stu[], int n, int m)
{
	int  i, j, t[6];
	for (j=0; j<m; j++)
	{
		printf("For course %d:\n", j+1);
	     memset(t, 0, sizeof(t));    // 将数组t的全部元素初始化为0 
		for (i=0; i<n; i++)
		{
			if (stu[i].score[j]>=0 && stu[i].score[j]<60)t[0]++;
			else if (stu[i].score[j]<70)				   t[1]++;
			else if (stu[i].score[j]<80)				   t[2]++;
			else if (stu[i].score[j]<90)				   t[3]++;
			else if (stu[i].score[j]<100)				   t[4]++;
			else if (stu[i].score[j] == 100)      		   t[5]++;
		}
		for (i=0; i<=5; i++)
		{
            if (i==0) printf("<60\t%d\t%.2f%%\n",t[i],(float)t[i]/n*100);
	       else if (i==5) printf("%d\t%d\t%.2f%%\n",
(i+5)*10,t[i],(float)t[i]/n*100);
	       else 	printf("%d-%d\t%d\t%.2f%%\n", 
(i+5)*10, (i+5)*10+9, t[i], (float)t[i]/n*100);	
		}
	}
}
// 函数功能： 打印学生成绩 
void PrintScore(STU stu[], int n, int m)
{
	int i, j;
	for (i=0; i<n; i++)
	{
		printf("%ld\t%s\t", stu[i].num, stu[i].name);
		for (j=0; j<m; j++)
		{
			printf("%.0f\t", stu[i].score[j]);
		}
		printf("%.0f\t%.0f\n", stu[i].sum, stu[i].aver);
	}
}
// 输出n个学生的学号、姓名及m门课程的成绩到文件student.txt中 
void WritetoFile(STU stu[], int n, int m)
{
	FILE *fp;
	int i, j;
     
	if ((fp = fopen("student.txt","w")) == NULL) 
	{ 
		printf("Failure to open score.txt!\n");
		exit(0);
	}
fprintf(fp, "%d\t%d\n", n, m);    //将学生人数和课程门数写入文件
	for (i=0; i<n; i++)
	{
		fprintf(fp, "%10ld%10s", stu[i].num, stu[i].name);
		for (j=0; j<m; j++)
		{
			fprintf(fp, "%10.0f", stu[i].score[j]);
		}
		fprintf(fp, "%10.0f%10.0f\n", stu[i].sum, stu[i].aver);
	}
	fclose(fp);
}
//从文件中读取学生的学号、姓名及成绩等信息写入到结构体数组stu中
void ReadfromFile(STU stu[],int *n, int *m)
{
	FILE *fp;
	int i, j;
	if ((fp = fopen("student.txt","r")) == NULL) 
	{ 
		printf("Failure to open score.txt!\n");
		exit(0);
	}
     fscanf(fp, "%d\t%d", n, m); // 从文件中读出学生人数和课程门数       
	for (i=0; i<*n; i++)  //学生人数保存在n指向的存储单元
	{
		fscanf(fp, "%10ld", &stu[i].num);
		fscanf(fp, "%10s", stu[i].name);  
		for (j=0; j<*m; j++)//课程门数保存在m指向的存储单元
		{
			fscanf(fp, "%10f", &stu[i].score[j]);          //不能用%10.0f
		}
		fscanf(fp, "%10f%10f", &stu[i].sum, &stu[i].aver);//不能用%10.0f
	}
	fclose(fp);		
}